#!/usr/bin/env node

console.log('create start!')

const program = require('commander')
const chalk = require('chalk')
const ora = require('ora')
const download = require('download-git-repo')
const tplObj = require(`${__dirname}/../template`)
program.usage('<template-name> [project-name]')
program.parse(process.argv)

// 当没有输入参数的时候给个提示
if (program.args.length < 1) return program.help()

//第一个参数是 template.json里面对应的模板框架的键名，第二个参数是 project-name
let templateName = program.args[0]
let projectName = program.args[1]

// 校验一下参数
if (!tplObj[templateName]) {
    console.log(chalk.red('\n Template does not exit! \n '))
    return
}

if (!projectName) {
    console.log(chalk.red('\n Project should not be empty! \n '))
    return
}

// 出现加载图标
const spinner = ora("Downloading...");
spinner.start();

// 执行下载方法并传入参数
download(
    tplObj[templateName],
    projectName,
    err => {
        if (err) {
            spinner.fail();
            console.log(chalk.red(`Generation failed. ${err}`))
            return
        }
        // 结束加载图标
        spinner.succeed();
        console.log(chalk.green('\n Create completed!'))
        console.log('\n To get started')
        console.log(`\n cd ${projectName}`)
        console.log(`\n npm run start \n`)
    }
)
